<template>
    <v-container grid-list-lg style="padding-left: 0px;">
        <v-layout justify-center row wrap text-center>
            <v-flex xs12>
                <v-img
                        :src="require('../assets/waveform.png')"
                        class="my-3"
                        contain
                        height="300"
                ></v-img>
            </v-flex>

            <v-flex mb-4>
                <h1 class="display-2 font-weight-bold mb-3">
                    Welcome to our sound analysis application
                </h1>
            </v-flex>

            <v-flex sm3>
                <v-btn @click="$refs.audio.click()" color="warning" block>
                    <v-icon>fas fa-lock</v-icon>
                    <div v-if="file===''">Select Audio File</div>
                    <div v-else>{{this.file.name}}</div>
                </v-btn>
                <input v-show="false" id="audioFile" ref="audio" type="file" @change="handleFileUpload">
            </v-flex>
            <v-flex sm3>
                <v-btn @click="postAudio()" :loading="loader" color="green" dark block>
                    <v-icon>mdi-arrow-right</v-icon>
                    Submit and Analyze
                </v-btn>
            </v-flex>

            <v-flex xs10>
                <audio controls ref="audioPlayer" autoplay></audio>
            </v-flex>
        </v-layout>


        <v-layout row wrap justify-center text-center>
            <v-flex xs6>
                <v-card color="blue lighten-2" height="100">
                    <v-card-text class="white--text text-xs-center">
                        <h2>Prediction: {{prediction}}</h2>
                        <h2>{{proba}}</h2>
                    </v-card-text>
                </v-card>
            </v-flex>
        </v-layout>

        <v-snackbar v-model="snackbar">
            {{snackbarMessage}}
            <v-btn color="primary" @click="snackbar=false">Close</v-btn>
        </v-snackbar>

    </v-container>
</template>

<script>
    import axios from 'axios'

    export default {
        data() {
            return {
                file: '',
                loader: false,
                snackbar: false,
                snackbarMessage: '',
                prediction: '',
                proba: ''
            }
        },
        methods: {
            handleFileUpload() {
                this.file = this.$refs.audio.files[0];
                this.bindAudioFile();
                this.displaySnackbar('File Loaded');
            },
            displaySnackbar(message) {
                this.snackbarMessage = message;
                this.snackbar = true;
            },
            bindAudioFile() {
                var blob = URL;
                var file = this.file;
                var fileURL = blob.createObjectURL(file);
                this.$refs.audioPlayer.src = fileURL;
            },
            postAudio() {
                let audioFormData = new FormData();
                audioFormData.append('file', this.file);

                this.loader = true;

                axios({
                    method: 'post',
                    url: 'http://localhost:5000',
                    data: audioFormData,
                    headers: {
                        'Content-Type':
                            'multipart/form-data'
                    }
                })
                    .then((response) => {

                    
                        this.loader = false;
                        if (response.status === 200) {
                            this.prediction = response.data.prediction;
                            this.proba = ' With confidence of ' + response.data.proba;
                        }
                    })
                    .catch((response) => {
                    
                        this.loader = false;
                        this.snackbarMessage = 'Error has occured: ' + response.message;
                        this.snackbar = true;
                    })

            }
        }

    };
</script>
